



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【CNMP系列】VIM编辑器详解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【CNMP系列】VIM编辑器详解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 09:44:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>缘起</h2>
<p>大学的时候做过Linux内核驱动程序研发，之前写C语言就是用的Vim编辑器，当年的Vim还不如今天之强大，当时的插件也没有现在这么多，只是觉得这个编辑器能满足我想要的所有，查看Linux内核代码，调试C程序，调试汇编代码，写Shell脚本，跑定时测试任务，等等等，都离不开这个编辑器。可能因为当年的机器为了节省几百块的操作系统费，被迫装上了Linux系统，后来才明白，这是上天指引着我来到了Linux这条道路，并且越陷越深。</p>
<p>以前总有人调侃程序员，说PHP是世界上最好的语言，今天带给大家的是CNMP系列的一个比较重量级的选手，Linux下的Vim编辑器。</p>
<p>毋庸置疑，Vim是世界上最棒的编辑器，有编辑器之神的称号，前身是Vi。功能强大，高度可定制是他的特性。</p>
<p>想要熟练使用Vim其实并不难，难就难在要改变你的一些习惯，比方说之前你用编辑器的时候右手肯定是要放在鼠标上面的，只有开始撸代码的时候才会将右手拿离鼠标。这不禁让我想到mac是最适合程序员的电脑，不会是因为他的鼠标就在键盘下侧吧，不过，讲真，mac的触摸板实在是太好用啦！</p>
<p>记住这句话：【vim设计之初就是整个文本编辑都用键盘而非鼠标来完成】，键盘上几乎每个键都有固定的用法，且vim的制作者希望用户在普通模式（也就是命令模式，只可输入命令）完成大部分的编辑工作。</p>
<h2>插入模式与命令模式</h2>
<p>Vim相较于其他编辑器，不同的地方在于，他有两种模式，第一种就是大家常见的，大部分编辑器都有的插入模式，第二种模式就是他区别于其他编辑器的命令模式。</p>
<p>熟练的使用命令模式能够让你感受到他不适用鼠标的正确性。</p>
<h3>两者切换方式</h3>
<p>进入Vim之后，键盘敲击</p>
<div>
<pre class="prettyprint linenums">i：在当前字符的左边插入<br />
I：在当前行首插入<br />
a：在当前字符的右边插入<br />
A：在当前行尾插入<br />
o：在当前行下面插入一个新行<br />
O：在当前行上面插入一个新行</pre>
</div>
<p>这些字符就可以进入插入模式，在插入模式中按【ESC】即可回到命令模式。</p>
<p>两者的切换，我最习惯的就是进入vim，按【a】进入编辑模式，然后狂按【ESC】进入命令模式。</p>
<h3>屏幕跳转控制命令</h3>
<p>【命令模式】</p>
<div>
<pre class="prettyprint linenums">&lt;Ctrl-f&gt;：向下移动一屏。<br />
&lt;Ctrl-d&gt;：向下移动半屏。<br />
&lt;Ctrl-b&gt;：向上移动一屏。<br />
&lt;Ctrl-u&gt;：向上移动半屏。</pre>
</div>
<p>跳转到多少行</p>
<p>【命令模式】</p>
<div>
<pre class="prettyprint linenums">numG：移动光标到指定的行（num）</pre>
</div>
<h3>剪切、拷贝、粘贴</h3>
<p>【命令模式】</p>
<div>
<pre class="prettyprint linenums">d：剪贴选择的内容到剪贴板。<br />
y：拷贝选择的内容到剪贴板。<br />
dd：剪切当前行。<br />
yy：拷贝当前行。<br />
p：在光标区粘贴剪贴板的内容</pre>
</div>
<h3>撤销</h3>
<p>【命令模式】</p>
<div>
<pre class="prettyprint linenums">u：撤销刚才编辑的内容</pre>
</div>
<p>高能提示！！！高能提示！！！高能提示！！！千万别在vim中使用&lt;ctrl+z&gt;，没用的。</p>
<h2>常用命令</h2>
<p>下面介绍一下你们在日常工作中可能会用到的一些命令</p>
<h3>查找命令</h3>
<div>
<pre class="prettyprint linenums">/text　　查找text，按n健查找下一个，按N健查找前一个。</pre>
</div>
<h3>替换命令</h3>
<div>
<pre class="prettyprint linenums">s/old/new/ 用old替换new，替换当前行的第一个匹配<br />
s/old/new/g 用old替换new，替换当前行的所有匹配<br />
%s/old/new/ 用old替换new，替换所有行的第一个匹配<br />
%s/old/new/g 用old替换new，替换整个文件的所有匹配<br />
:, s/^/    /g 在第10行知第20行每行前面加四个空格，用于缩进。</pre>
</div>
<h3>退出命令</h3>
<div>
<pre class="prettyprint linenums">:wq 保存并退出<br />
:q! 强制退出并忽略所有更改<br />
:e! 放弃所有修改，并打开原来文件。</pre>
</div>
<p>至此为止，你可以编辑你想要编辑的东西了，和一般的编辑器没多大的区别啦~</p>
<h2>Vim插件</h2>
<p>下面进入主题，vim的一大特色，他的高可扩展性！插件的安装与使用</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/465728/201703/465728-20170322201408908-10616722.png" /></p>
<p>左侧为Vim插件文件管理器【NERDTree】，后面我会给大家详细解答。</p>
<p>右侧为我的vimrc文件部分内容。</p>
<h3>插件管理器</h3>
<p>提起插件，大家第一个想到的就是管理器，类似于包管理器，Python的pip，PHP的Composer，CentOS的yum，Ubuntu的apt-get，Mac的brew，是不是很情切，啊。</p>
<p>那Vim也有自己的插件管理器，那就是大名鼎鼎的【vundle】，最老牌的Vim插件管理器。</p>
<p>按照如下方式下载vundle并安装</p>
<div>
<pre class="prettyprint linenums">#git clone https://github.com/gmarik/Vundle.vim.git ~/.vim/bundle/Vundle.vim</pre>
</div>
<p>该命令将下载Vundle插件管理器，并将它放置在你的Vim编辑器bundles文件夹中。现在，你可以通过.vimrc配置文件来管理所有扩展了。</p>
<h3>vimrc</h3>
<p>vim的配置文件，你想要的功能，包括插件的下载安装，都是配置在这个目录下的，然后在命令模式下输入</p>
<div>
<pre class="prettyprint linenums">:PluginInstall</pre>
</div>
<p>即可完成对插件的安装，别忘了前面有个【:】哈。</p>
<p>首先，我们先看下你的home目录下是否存在vimrc文件，默认是不存在的，如果你之前编辑过的，可以，没关系，我们从头再来过一遍。</p>
<div>
<pre class="prettyprint linenums">#ls ~/.vimrc</pre>
</div>
<p>【~】是Linux下对应用户的home目录。</p>
<p>没有的话，那就touch一个吧，或者直接vim一个，直接编辑即可。</p>
<div>
<pre class="prettyprint linenums">#touch ~/.vimrc</pre>
</div>
<p>编辑上面的.vimrc文件，把下载下来的Vundle配置添加到配置文件的顶部：</p>
<div>
<pre class="prettyprint linenums">set nocompatible              " required<br />
filetype off                  " required

" set the runtime path to include Vundle and initialize<br />
set rtp+=~/.vim/bundle/Vundle.vim<br />
call vundle#begin()

" alternatively, pass a path where Vundle should install plugins<br />
"call vundle#begin('~/some/path/here')

" let Vundle manage Vundle, required<br />
Plugin 'gmarik/Vundle.vim'

" Add all your plugins here (note older versions of Vundle used Bundle instead of Plugin)</pre>
</div>
<p>注：" 开头的是注释</p>
<h3>插件的安装</h3>
<p>先来装个插件试试吧，就从刚才的那个文件管理器开始吧。</p>
<p>在上面的vimrc文件中新增一行</p>
<div>
<pre class="prettyprint linenums">Plugin 'scrooloose/nerdtree'</pre>
</div>
<p>在命令模式下输入【:PluginInstall】</p>
<p>如果出现如下的界面，就表示安装成功啦！</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/465728/201703/465728-20170322203048783-368626666.png" /></p>
<p>最左边的窗口就是插件安装的显示页面，安装成功的插件全部会显示在这边，怎么在几个分割窗口间跳转呢，按&lt;ctrl+ww&gt;，记住，是两个w哟。</p>
<p>关闭某个窗口，跳到那个窗口，命令模式输入【:q】即可关闭。</p>
<p>什么？打开没有文件夹目录？因为你还没有打开NERDTree呢，命令行输入NERDTree即可打开文件夹管理目录了，如果想要打开就会显示当前的文件夹，在vimrc中输入下面两行即可</p>
<div>
<pre class="prettyprint linenums">autocmd VimEnter * NERDTree<br />
let NERDTreeShowBookmarks= </pre>
</div>
<h3>代码自动补齐</h3>
<p>YouCompleteMe&nbsp;- 前Google的C++工程师Valloric (Val Markovic)&nbsp;开发的一款，专门用于C系（C,C++,C#) 的自动补全工具, 优点是速度非常快，而且支持变量跳转，函数关联跳转，检测代码报错, 可以说是最牛逼的补全工具，缺点是太难配置，对于除了C系语言的其他语言补全支持并不好. 对于刚接触Vim的同学来说相当不友好,&nbsp;不过文档比较齐全.</p>
<h3>Git版本控制</h3>
<p>只支持Git 的高亮，速度非常不错</p>
<div>
<pre class="prettyprint linenums">Plugin 'vim-gitgutter'</pre>
</div>
<h3>更新和安装插件</h3>
<p>编辑好vimrc文件之后，需要在命令模式下输入下面命令才能更新和安装插件</p>
<div>
<pre class="prettyprint linenums">:source %<br />
:PlugInstall</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/465728/201703/465728-20170322204950893-809470177.png" /></p>
<p>更改在git管理下的代码，新增一行，左侧就会出现一个小+号。</p>
<h3>常用的vimrc配置命令</h3>
<p>大多数&ldquo;现代&rdquo;集成开发环境（IDE）都提供对方法（methods）或类（classes）进行折叠的手段，只显示类或方法的定义部分，而不是全部的代码。</p>
<p>你可以在<code>.vimrc</code>中添加下面的代码开启该功能：</p>
<div>
<pre class="prettyprint linenums">" Enable folding<br />
set foldmethod=indent<br />
set foldlevel=</pre>
</div>
<p>你必须手动输入<code>za</code>来折叠（和取消折叠）。</p>
<p>让Vim中的Tab键就相当于4个标准的空格符，确保每行代码长度不超过80个字符，并且会以unix格式储存文件，避免在推送到Github或分享给其他用户时出现文件转换问题。</p>
<div>
<pre class="prettyprint linenums">set tabstop=<br />
set softtabstop=<br />
set shiftwidth=<br />
set textwidth=<br />
set expandtab<br />
set autoindent<br />
set fileformat=unix</pre>
</div>
<p>支持UTF-8编码</p>
<div>
<pre class="prettyprint linenums">set encoding=utf-</pre>
</div>
<p>开启显示行号：</p>
<div>
<pre class="prettyprint linenums">set nu</pre>
</div>
<p>语法高亮显示</p>
<div>
<pre class="prettyprint linenums">syntax on</pre>
</div>
<p>关于vim的所有就讲到这里，vim其实有很多，包括linux，其实有很多可以让我们去学习的地方，我指的学习不单单是指工具的使用，而是代码层面的学习，尤其是Linux内核的相关源码，可以让你学到很多变成思想，也可以说是算法，真的很精辟，看过的人都知道~~~</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvvdloq.html">tftp-nfs开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zvn239.html">zookeeper原理及作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p2mpd8.html">Android UI设计中一些不错的示例及第三方控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxjp7d9.html">开篇&amp;amp&semi;TexturePacker打出图集给UGUI使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvl4218.html">HTML语言特殊字符对照表&lpar;ISO Latin-1字符集&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/390w2djq.html">【转载】jQuery插件开发精品教程，让你的jQuery提升一个台阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvgxpoq.html">手动purge优化器的统计信息与AWR快照，减少对sysaux表空间的占用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1o7x59.html">Xcode7 制作通用的framework（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0v74eq.html">try catch finally 关闭流标准的写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnmzwq.html">Sdut 2165 Crack Mathmen&lpar;数论）&lpar;山东省ACM第二届省赛E 题&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v56d48.html">图的遍历（bfs 和dfs）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz3eye8.html">Linux环境下将Oracle11g数据库模式由非归档模式（Noarchivelog）修改为自动归档模式（archivelog）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk7xre8.html">Win Server 2003 10条小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojzzdlq.html">周末班：Python基础之模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5g654q.html">vue实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603v249.html">object detection&lbrack;rfcn&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj51z79.html">POJ 3177 Redundant Paths &lpar;边双连通&plus;缩点&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2kpdx9.html">设置div 高度 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd0j3z9.html">排序算法&lpar;3&rpar;--Insert Sorting--插入排序&lbrack;3&rsqb;--Shell Sort--希尔排序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4ko4xq.html">CasperJS断言</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ojvz1eq.html">iOS网络层设计感想</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj236x8.html">swift注意</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yd5zn8.html">EntityFramewok Core 1&period;1连接MSSql数据库详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey5dzx9.html">Java内部类基本使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1zgroq.html">lable  以及cell的高度自适应</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zlpjx9.html">block之---数据传递</a>
			</li>
						<li><a href="https://www.batexi.com/a/8melo30q.html">关于JavaScript中的编码和解码函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj5nnpq.html">Unity预计算光照的学习&lpar;速度优化&comma;LightProb&comma;LPPV&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kjkjz9.html">jQuery ajax&lpar;&rpar;    参数&comma;回调函数，数据类型，发送数据到服务器，高级选项</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpopxzq.html">DevExpreess汉化使用方法及汉化包</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
